import axios, { AxiosRequestConfig } from 'axios';
import jwt_decode from 'jwt-decode';
import {} from '../controllers';
import { store } from '../store';

export const API = (
  method: string,
  url: string,
  data?: {} | null,
  headers?: {} | null
) => {
  const API = axios.create({
    baseURL: process.env.REACT_APP_BASE_URL
  });

  API.interceptors.request.use(
    async config => {
      const {} = store.getState();

      if (
        config.headers?.authorization
        config.url !== '<REFRESH TOKEN URL>' &&
        store.getState()
      ) {
        const { exp }: { exp: number } = jwt_decode('<TOKEN FROM STORE>');

        if (exp * 1000 - 30000 < Date.now()) {
          // await store.dispatch();

          const {} = store.getState();

          config.headers.authorization = `Bearer ${'<TOKEN FROM STORE>'}`;
        }
      }

      return config;
    },
    error => {
      return Promise.reject(error);
    },
  );

  return API.request({ method, url, data, headers } as AxiosRequestConfig);
};

/* CONTROLLER_EXPORTS */
